package com.twt.twitter;

import thinktank.twitter.Twitter;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.TimerTask;

public class TwitterExecutor extends TimerTask {
    protected static final String USER_NAME = "twitter.user.name";
    protected static final String USER_PASSWORD = "twitter.user.password";
    protected static final String EXEC_PATTERN = "RUN@";
    private String userName;
    private String password;

    /**
     * Constructor
     *
     * @throws IOException
     */
    public TwitterExecutor() throws IOException {
        userName = System.getProperty(USER_NAME);
        password = System.getProperty(USER_PASSWORD);
    }

    public ExecutorResult execute(String cmd) throws IOException, InterruptedException {
        Process p = Runtime.getRuntime().exec(cmd.trim());
        BufferedReader prcOut = new BufferedReader(
                new InputStreamReader(
                        new BufferedInputStream(p.getInputStream())));

        ExecutorResult result = new ExecutorResult();
        String output;
        while ((output = prcOut.readLine()) != null) {
            result.setOutput(result.getOutput() + "\n" + output);
        }
        prcOut.close();
        prcOut = null;
        int exitValue = p.waitFor();
        result.setExitStatus(exitValue);
        return result;
    }

    public void start() throws IOException, InterruptedException {
        Twitter twitter = new Twitter(userName, password);
        Twitter.Status status = twitter.getStatus(userName);
        if (status.getText().startsWith(EXEC_PATTERN)) {
            String cmds[] = status.getText().split(EXEC_PATTERN);
            String cmd = "";
            for (String str : cmds) {
                cmd += str;
            }
            System.out.println("Running command: " + cmd);
            ExecutorResult result = execute(cmd);
            System.out.println("Output: " + result.getOutput());
            System.out.println("Exit: " + result.getExitStatus());
            if (result.getOutput() != null) {
                String output = result.getOutput();
                if (output.length() > 130) {
                    int count = output.length() % 130;
                    for (int i = 0; i < count; i++) {
                        int startIndex = i * 130;
                        int endIndex = (i * 130) + 130;
                        if (endIndex > output.length()) endIndex = output.length() - 1;
                        String text = output.substring(startIndex, endIndex);
                        twitter.updateStatus(text);
                    }
                } else {
                    twitter.updateStatus(output);
                }
            }
        } else {
            System.out.println("Not a command: " + status.getText());
        }
    }

    public void run() {
        try {
            start();
        } catch (Exception e) {
            System.err.println("Error: " + e.getMessage());
        }
    }


}
